/* Copyright U S WEST Advanced Technologies, Inc.
 * You may use, copy, modify and sublicense this Software
 * subject to the conditions expressed in the file "License".
 */

#include "apl.h"
#include "char.h"
#include "opt_codes.h"

char *opname[] = {

   "eol",      /* 0 */
   "add",      /* 1 */
   "plus",      /* 2 */
   "sub",      /* 3 */
   "minus",   /* 4 */
   "mul",      /* 5 */
   "sgn",      /* 6 */
   "div",      /* 7 */
   "recip",   /* 8 */
   "mod",      /* 9 */
   "abs",      /* 10 */
   "min",      /* 11 */
   "floor",   /* 12 */
   "max",      /* 13 */
   "ceil",      /* 14 */
   "pwr",      /* 15 */
   "exp",      /* 16 */
   "log",      /* 17 */
   "loge",      /* 18 */
   "cir",      /* 19 */
   "pi",      /* 20 */
   "comb",      /* 21 */
   "fac",      /* 22 */
   "deal",      /* 23 */
   "rand",      /* 24 */
   "drho",      /* 25 */
   "mrho",      /* 26 */
   "diot",      /* 27 */
   "miot",      /* 28 */
   "rot0",      /* 29 */
   "rev0",      /* 30 */
   "dtrn",      /* 31 */
   "mtrn",      /* 32 */
   "dibm",      /* 33 */
   "mibm",      /* 34 */
   "gdu",      /* 35 */
   "gduk",      /* 36 */
   "gdd",      /* 37 */
   "gddk",      /* 38 */
   "exd",      /* 39 */
   "scan",      /* 40 */
   "exdk",      /* 41 */
   "scank",   /* 42 */
   "iprod",   /* 43 */
   "oprod",   /* 44 */
   "quad",      /* 45 */
   "qquad",   /* 46 */
   "br0",      /* 47 */
   "br",      /* 48 */
   "ddom",      /* 49 */
   "mdom",      /* 50 */
   "com",      /* 51 */
   "red",      /* 52 */
   "comk",      /* 53 */
   "redk",      /* 54 */
   "rot",      /* 55 */
   "rev",      /* 56 */
   "rotk",      /* 57 */
   "revk",      /* 58 */
   "cat",      /* 59 */
   "rav",      /* 60 */
   "catk",      /* 61 */
   "ravk",      /* 62 */
   "print",   /* 63 */
   "quot",      /* 64 */
   "elid",      /* 65 */
   "cquad",   /* 66 */
   "comnt",   /* 67 */
   "index",   /* 68 */
   "hprint",   /* 69 */
   0,         /* 70 */
   "lt",      /* 71 */
   "le",      /* 72 */
   "gt",      /* 73 */
   "ge",      /* 74 */
   "eq",      /* 75 */
   "ne",      /* 76 */
   "and",      /* 77 */
   "or",      /* 78 */
   "nand",      /* 79 */
   "nor",      /* 80 */
   "not",      /* 81 */
   "eps",      /* 82 */
   "meps",      /* 83 */
   "rep",      /* 84 */
   "take",      /* 85 */
   "drop",      /* 86 */
   "exd0",      /* 87 */
   "asgn",      /* 88 */
   "immed",   /* 89 */
   "name",      /* 90 */
   "const",   /* 91 */
   "fun",      /* 92 */
   "arg1",      /* 93 */
   "arg2",      /* 94 */
   "auto",      /* 95 */
   "rest",      /* 96 */
   "com0",      /* 97 */
   "red0",      /* 98 */
   "exd0",      /* 99 */
   "scan0",   /*100 */
   "base",      /*101 */
   "format",   /*102 */
   "label",   /*103 */
   0,			/*104 */
   S_QUAD "lx",		/*105 */
   S_QUAD "av",		/*106 */
   S_QUAD "ts",		/*107 */
   S_QUAD "pp",		/*108 */
   S_QUAD "pw",		/*109 */
   S_QUAD "ct",		/*110 */
   S_QUAD "io",		/*111 */
   S_QUAD "run",	/*112 */
   S_QUAD "fork",	/*113 */
   S_QUAD "wait",	/*114 */
   S_QUAD "exec",	/*115 */
   S_QUAD "fx",		/*116 */
   S_QUAD "exit",	/*117 */
   S_QUAD "pipe",	/*118 */
   S_QUAD "chdir",	/*119 */
   S_QUAD "open",	/*120 */
   S_QUAD "close",	/*121 */
   S_QUAD "read",	/*122 */
   S_QUAD "write",	/*123 */
   S_QUAD "creat",	/*124 */
   S_QUAD "seek",	/*125 */
   S_QUAD "rm",		/*126 */
   S_QUAD "rd",		/*127 */
   S_QUAD "dup",	/*128 */
   S_QUAD "ap",		/*129 */
   S_QUAD "kill",	/*130 */
   S_QUAD "cr",		/*131 */
   "dfmt",      /*132 */
   "mfmt",      /*133 */
   S_QUAD "nc",		/*134 */
   "nilret",   /*135 */
   S_QUAD "lx",		/*136 */
   "ibr",      /*137 */
   "ibr0",      /*138 */
   "rval",      /*139 */
   S_QUAD "sig",	/*140 */
   S_QUAD "float",	/*141 */
   S_QUAD "nl",		/*142 */
};

/* System Command op-codes */
char *sysops[] = {

   "err",	/* 0 */
   "clear",	/* 1 */
   "err",	/* 0 */
   "edit",	/* 3 */
   "erase",	/* 4 */
   "fns",	/* 5 */
   "err",	/* 0 */
   "read",	/* 7 */
   "err",	/* 0 */
   "vars",	/* 9 */
   "err",	/* 0 */
   "debug",	/* 11 */
   "off",	/* 12 */
   "load",	/* 13 */
   "save",	/* 14 */
   "copy",	/* 15 */
   "contin",	/* 16 */
   "lib",	/* 17 */
   "dropc",	/* 18 */
   "err",	/* 0 */
   "script",	/* 20 */
   "dell",	/* 21 */
   "trace",	/* 22 */
   "untarce",	/* 23 */
   "write",	/* 24 */
   "siclear",	/* 25 */
   "sicom",	/* 26 */
   "code",	/* 27 */
   "err",	/* 0 */
   "shell",	/* 29 */
   "list",	/* 30 */
   "prws",	/* 31 */
   "memory",	/* 32 */
};


void code_dump(cp, flag)
char *cp;
{
   char *s, *t;
   int i;

   s = cp;
   if(flag) printf("[ ");

loop:
   putchar(' ');
   if(column > 50) {
      if(flag) printf(" ]\n[ ");
      else putchar('\n');
   }
   i = *s++;
   if(i != EOF) i &= 0377;
   if(i >= 0 && i <= 142 && opname[i]) {
      t = opname[i];
      while(*t) putchar(*t++);
   }
   else if(i != EOF) printf("%d ", i);
   switch(i) {

   case EOL:
      if(*s != EOL) break;
   case EOF:
      printf(".");
      if(flag) printf(" ].");
      putchar('\n');
      return;

   case QUOT:
      i = *s++;
      s += i;
      break;

   case CONST:
      i = *s++;
      s += i*SDAT;
      break;

   case NAME:
   case FUN:
   case ARG1:
   case ARG2:
   case AUTO:
   case REST:
   case RVAL:
      s += copy(IN, s, &cp, 1);
      putchar('-');
      t = ((struct nlist *)cp)->namep;
      while(*t) putchar(*t++);
      break;

   case INDEX:
      s++;
      break;
   case IMMED:
      i = *s++;
      putchar('-');
      if(i > 0 && i <= 32 && sysops[i]) {
        t = sysops[i];
        while(*t) putchar(*t++);
      }
      break;
   }
   goto loop;
}

